#include <gnome.h>

void button_clicked(GtkWidget * button, gpointer data)
{
        GtkEntry * entry = data;
        GError * error = NULL;
	const char * url = gtk_entry_get_text(entry);
        if (!gnome_url_show(url, &error)) {
          g_print("%s\n", error->message);
          g_error_free(error);
        }
 }

gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
        gtk_main_quit();
        return FALSE;
}

int main(int argc, char * argv[])
{
	GnomeProgram * gnome_prog;
        GtkWidget * mainwnd;
        GtkWidget * hbox;
        GtkWidget * button;
	GtkWidget * entry;
	gnome_prog = gnome_program_init("openurl", "0.1", LIBGNOMEUI_MODULE, argc, argv, NULL, NULL);
        mainwnd = gnome_app_new ("openurl",
                             "Открыть URL");
        gtk_signal_connect (GTK_OBJECT (mainwnd), "delete_event",
                            GTK_SIGNAL_FUNC(delete_event), NULL);
        hbox = gtk_hbox_new (FALSE,5);
        entry = gtk_entry_new();
        gtk_box_pack_start (GTK_BOX(hbox), entry, TRUE, TRUE, 0);
        button = gtk_button_new_with_label("Открыть");
        gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (button_clicked),
                            entry);
        gtk_box_pack_start (GTK_BOX(hbox), button, FALSE, FALSE, 0);
        gnome_app_set_contents (GNOME_APP (mainwnd), hbox); 
        gtk_widget_show_all(mainwnd);
        gtk_main ();
        return 0;
}
